#include "textures.hpp"
#include <stdlib.h>
#include <string.h>
#include <SDL2/SDL.h>
#include <iostream>

SDL_Surface *bitmapSurface[4]= {};
SDL_Texture * bitmapTexture[4] = {};
static std::string color_paths[] = {"blue", "green", "red", "yellow"};
static std::string sprite_path = "../sdl_sprites/";

void init_textures(SDL_Renderer *in_renderer)
{
    for (size_t color = 0; color < 4; color++)
    {
        bitmapSurface[color] = SDL_LoadBMP((sprite_path+color_paths[color]+".bmp").c_str());
        bitmapTexture[color] = SDL_CreateTextureFromSurface(in_renderer, bitmapSurface[color]);
    }
    
}

SDL_Texture * get_texture(int color)
{
    return bitmapTexture[color];
}
