#include "hal.hpp"
#include "npp.h"
#include <cuda.h>
#include <cuda_runtime.h>

std::vector<float> hal_vector_f32_cross_multiply(std::vector<float>& a, std::vector<float>& b)
{
    Npp32f * pSrca; 
    Npp32f * pSrcb; 
    cudaMallocManaged((void **)(&pSrca), long(sizeof(Npp32f) * a.size()));
    cudaMallocManaged((void **)(&pSrcb), long(sizeof(Npp32f) * b.size()));
    cudaMemcpy(pSrca, &a[0], sizeof(Npp32f) * a.size(), cudaMemcpyHostToDevice);
    cudaMemcpy(pSrcb, &b[0], sizeof(Npp32f) * b.size(), cudaMemcpyHostToDevice);
    std::vector<float> ret_vec;
    ret_vec = b;
    Npp32f * pSrcc; 
    cudaMallocManaged((void **)(&pSrcc), long(sizeof(Npp32f) * ret_vec.size()));
    NppStatus status = nppsMul_32f(pSrca, pSrcb, pSrcc, a.size());
    cudaDeviceSynchronize();
    cudaMemcpy(&ret_vec[0], pSrcc, sizeof(Npp32f) * ret_vec.size(), cudaMemcpyDeviceToHost);
    cudaFree(pSrca);
    cudaFree(pSrcb);
    cudaFree(pSrcc);
    return ret_vec;
}
